'use strict';

var babelTemplate = require('babel-template');

/**
 * @param {String} name
 * @param {Object} t
 */
module.exports = function (name, t) {
    var template = babelTemplate(name + '(FUNCTION_NAME, NAME, ARGUMENT, VALIDATOR);');

    return function (functionName, name, argument, validator) {
        return template({
            FUNCTION_NAME: functionName ? t.stringLiteral(functionName) : t.stringLiteral('Unnamed function'),
            NAME: t.stringLiteral(name),
            ARGUMENT: argument,
            VALIDATOR: validator
        });
    };
};